'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.State = undefined;
exports.searchState = searchState;

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _immutable = require('immutable');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var State = exports.State = function State() {
  _classCallCheck(this, State);
};

function searchState(state, fqdn, type, address) {
  if (typeof state === 'string') var state = (0, _immutable.fromJS)(JSON.parse(state));
  if (type == "height") {
    return state.get('height');
  } else if (type == "nonces") {
    return state.get('works.credits.core').get('nonces').get(address) || 0;
  } else if (type == "validators") {
    var res = state.get('works.credits.core').get('validators').get(address);
    if (res === undefined) {
      return null;
    }
    return res;
  } else {
    try {
      var _res = state.get(fqdn).get(type).get(address);
      if (_res === undefined) {
        return null;
      }
      return _res;
    } catch (e) {
      return null;
    }
  }
}